com.io7m.jregions.core.parameterized.areas

## Class PAreaD<S>

- java.lang.Object
- - com.io7m.jregions.core.parameterized.areas.PAreaD<S>

- Type Parameters:
    `S` - A phantom type parameter indicating the coordinate space of the area
  All Implemented Interfaces:
    PAreaDType<S>, AreaValuesDType, AreaSizeValuesDType

      @Generated(value={"Immutables.generator","PAreaDType<S>"})
      public final class PAreaD<S>
      extends Object
      implements PAreaDType<S>

  An area with `double` coordinates.

  The coordinates of the area are given in half-closed form. That is, `minimumX()` refers to the minimum inclusive value on the X axis, and `maximumX()` refers to the maximum exclusive value on the X axis. Likewise for the Y axis.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `PAreaD.Builder<S>` Builds instances of type `PAreaD`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <S> PAreaD.Builder<S>` | `builder()` Creates a builder for `PAreaD`.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `PAreaD` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `minimumX`, `maximumX`, `minimumY`, `maximumY`.
    `double` | `height()` Deprecated. Use `AreaValuesDType.sizeY()`
    `double` | `maximumX()`
    `double` | `maximumY()`
    `double` | `minimumX()`
    `double` | `minimumY()`
    `static <S> PAreaD<S>` | `of(double minimumX, double maximumX, double minimumY, double maximumY)` Construct a new immutable `PAreaD` instance.
    `String` | `toString()` Prints the immutable value `PAreaD` with attribute values.
    `double` | `width()` Deprecated. Use `AreaValuesDType.sizeX()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.io7m.jregions.core.parameterized.areas.PAreaDType

      `checkPreconditions`

    - ### Methods inherited from interface com.io7m.jregions.core.unparameterized.areas.AreaValuesDType

      `sizeX, sizeY`

- - ### Method Detail

    - #### minimumX

          public double minimumX()

      Specified by:
        `minimumX` in interface `PAreaDType<S>`
      Specified by:
        `minimumX` in interface `AreaValuesDType`
      Returns:
        The value of the `minimumX` attribute

    - #### maximumX

          public double maximumX()

      Specified by:
        `maximumX` in interface `PAreaDType<S>`
      Specified by:
        `maximumX` in interface `AreaValuesDType`
      Returns:
        The value of the `maximumX` attribute

    - #### minimumY

          public double minimumY()

      Specified by:
        `minimumY` in interface `PAreaDType<S>`
      Specified by:
        `minimumY` in interface `AreaValuesDType`
      Returns:
        The value of the `minimumY` attribute

    - #### maximumY

          public double maximumY()

      Specified by:
        `maximumY` in interface `PAreaDType<S>`
      Specified by:
        `maximumY` in interface `AreaValuesDType`
      Returns:
        The value of the `maximumY` attribute

    - #### width

          @Deprecated
          public double width()

      Deprecated. Use `AreaValuesDType.sizeX()`
      Specified by:
        `width` in interface `AreaSizeValuesDType`
      Returns:
        The width of the area

    - #### height

          @Deprecated
          public double height()

      Deprecated. Use `AreaValuesDType.sizeY()`
      Specified by:
        `height` in interface `AreaSizeValuesDType`
      Returns:
        The height of the area

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `PAreaD` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `minimumX`, `maximumX`, `minimumY`, `maximumY`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `PAreaD` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static <S> PAreaD<S> of(double minimumX,
                                         double maximumX,
                                         double minimumY,
                                         double maximumY)

      Construct a new immutable `PAreaD` instance.
      Parameters:
        `minimumX` - The value for the `minimumX` attribute
        `maximumX` - The value for the `maximumX` attribute
        `minimumY` - The value for the `minimumY` attribute
        `maximumY` - The value for the `maximumY` attribute
      Returns:
        An immutable PAreaD instance

    - #### builder

          public static <S> PAreaD.Builder<S> builder()

      Creates a builder for `PAreaD`.
      Type Parameters:
        `S` - generic parameter S
      Returns:
        A new PAreaD builder

Copyright © 2017 <code@io7m.com> http://io7m.com